import {
  CGrid
} from "./chunk-FURBXBKQ.mjs";
import {
  __name
} from "./chunk-INDHDMU3.mjs";

// src/simple-grid.tsx
import { createVNode as _createVNode, isVNode as _isVNode, mergeProps as _mergeProps } from "vue";
import { defineComponent, computed } from "vue";
import { SNAO } from "@chakra-ui/vue-utils";
import { isNull, isNumber, mapResponsive } from "@chakra-ui/utils";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !_isVNode(s);
}
__name(_isSlot, "_isSlot");
var CSimpleGrid = defineComponent({
  name: "CSimpleGrid",
  props: {
    as: {
      type: [Object, String],
      default: "ul"
    },
    minChildWidth: SNAO,
    columns: SNAO,
    spacing: SNAO,
    spacingX: SNAO,
    spacingY: SNAO
  },
  setup(props, {
    slots,
    attrs
  }) {
    const templateColumns = computed(() => props.minChildWidth ? widthToColumns(props.minChildWidth) : countToColumns(props.columns));
    return () => _createVNode(CGrid, _mergeProps({
      "as": props.as,
      "__label": "simple-grid",
      "gap": props.spacing,
      "columnGap": props.spacingX,
      "rowGap": props.spacingY,
      "templateColumns": templateColumns.value
    }, attrs), _isSlot(slots) ? slots : {
      default: () => [slots]
    });
  }
});
function toPx(n) {
  return isNumber(n) ? `${n}px` : n;
}
__name(toPx, "toPx");
function widthToColumns(width) {
  return mapResponsive(width, (value) => isNull(value) ? null : `repeat(auto-fit, minmax(${toPx(value)}, 1fr))`);
}
__name(widthToColumns, "widthToColumns");
function countToColumns(count) {
  return mapResponsive(count, (value) => isNull(value) ? null : `repeat(${value}, minmax(0, 1fr))`);
}
__name(countToColumns, "countToColumns");

export {
  CSimpleGrid
};
